/*
SG C Tools 1.5

(C) 1993 Steve Goldsmith
All Rights Reserved

Compiled with HI-TECH C 3.09 (CP/M-80).
*/

#define pcxErrNone    0
#define pcxErrFile    1
#define pcxErrHeader  2
#define pcxErrNotPCX  3
#define pcxErrNot2Bit 4

typedef struct
{
  uchar Manufacturer;
  uchar Version;
  uchar Encoding;
  uchar BitsPerPixel;
  short XMin;
  short YMin;
  short XMax;
  short YMax;
  short HRes;
  short VRes;
  uchar Palette[48];
  uchar Reserved;
  uchar ColorPlanes;
  short BytesPerLine;
  short PaletteType;
  uchar Filler[58];
} pcxHead;

short initpcx(char *FileName);
void donepcx(void);

void decodelinepcx(ushort X, ushort Y);
void decodefilepcx(ushort X, ushort Y);

void decodelineintpcx(ushort X, ushort Y);
void decodefileintpcx(ushort X, ushort Y);
